Subject: Re: Entering French Characters into Pine (Pico) - ANSWER!

From: Ian Barnett <[email-masked]>
Date: Tue, 13 Jun 1995 09:31:01 -0400

Sorry, I took so long responding to the requests for the info on how to 
modify UNIX (non-DOS) PICO to allow for foreign character input. 

As has been pointed out to me by some of the respondents to my original post
, using this modification from within PINE to try and send mail with accented
characters can result in mixed results. Not all computers on the Internet
will pass on 8 bit characters in mail messages. Consequently, these characters
will sometimes get sent without there 8th bit causing lost characters. In our
environment we have no problem sending mail with 8 bit characters 
internally, but your mileage may vary. All the machines in our 
environment are set for 8 bit. 

One way to solve this 8 bit - 7 bit problem is to create your mail 
message in pico (outside of PINE) UUENCODE or ROT it and mail the 
resulting file. At least now you will be able to enter all your 
foreign characters into PICO.

The following modifications were made to the pico.c program found in version
3.91 of Pine.

Beginning at line 372

Old Code
========

#ifdef	DOS
    if (c>=0x20 && c<=0xFF) {
#else
    if ((c>=0x20 && c<=0x7E) || (c>=0xA0 && c<=0xFE)) { /* Self inserting.  */ 
#endif

New Code
========
#ifdef	DOS
    if (c>=0x20 && c<=0xFF) {
#else
    if ((c>=0x20 && c<=0x7E) || (c>=0x80 && c<=0xFE)) { /* Self inserting.  */ 
#endif

As you can see the only difference is in the #else line. I changed the 0xA0 to
0x80. I am not sure why the range containing most of the foreign characters 
was purposefully excluded, but I included them and have had no problems.

Ian Barnett
Mgr, Sys Admin & Support
George Brown College
Toronto, Ont.